JDBCBlobFile (HSQLDB 2.4.1 API)
Date: 2018-05-20

org.hsqldb.jdbc

## Class JDBCBlobFile

- java.lang.Object
- - org.hsqldb.jdbc.JDBCBlobFile

- All Implemented Interfaces:
    java.sql.Blob

      public class JDBCBlobFile
      extends java.lang.Object
      implements java.sql.Blob

  ### HSQLDB-Specific Information:

  Starting with 2.1, in addition to HSQLDB driver support for both client-side in-memory and remote SQL CLOB data implementations, this class is provided to expose efficient, relatively high-performance BLOB operations over client accessible files.

  Design Notes

  Although it is possible to implement a transactional version of this class, the present implementation directly propagates changes to the underlying file such that changes become visible as soon as they are either implicitly or explicitly flushed to disk.

  Since:
    HSQLDB 2.1
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `TEMP_FILE_PREFIX`
    `static java.lang.String` | `TEMP_FILE_SUFFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JDBCBlobFile()` Convenience constructor; equivalent to JDBCBlobFile(true);
    `JDBCBlobFile(boolean deleteOnFree)` Constructs a new instance backed by a File object created in response to invoking File.createTempFile(TEMP_FILE_PREFIX,TEMP_FILE_SUFFIX)
    `JDBCBlobFile(java.io.File file)` Convenience constructor; equivalent to JDBCBlobFile(file, false);
    `JDBCBlobFile(java.io.File file, boolean deleteOnFree)` Constructs a new instance backed by the given File object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `free()` This method frees the `Blob` object and releases the resources that it holds.
    `java.io.InputStream` | `getBinaryStream()` Retrieves the `BLOB` value designated by this `Blob` instance as a stream.
    `java.io.InputStream` | `getBinaryStream(long pos, long length)` Returns an `InputStream` object that contains a partial `Blob` value, starting with the byte specified by pos, which is length bytes in length.
    `byte[]` | `getBytes(long pos, int length)` Retrieves all or part of the `BLOB` value that this `Blob` object represents, as an array of bytes.
    `java.io.File` | `getFile()` Retrieves the canonical `File` object denoting the file that backs this BLOB.
    `boolean` | `isDeleteOnFree()` Retrieves whether an attempt to delete the backing file is made in response to invocation of `free()`.
    `long` | `length()` Returns the number of bytes in the `BLOB` value designated by this `Blob` object.
    `long` | `position(java.sql.Blob pattern, long start)` Retrieves the byte position in the `BLOB` value designated by this `Blob` object at which `pattern` begins.
    `long` | `position(byte[] pattern, long start)` Retrieves the byte position at which the specified byte array `pattern` begins within the `BLOB` value that this `Blob` object represents.
    `java.io.OutputStream` | `setBinaryStream(long pos)` Retrieves a stream that can be used to write to the `BLOB` value that this `Blob` object represents.
    `int` | `setBytes(long pos, byte[] bytes)` Writes the given array of bytes to the `BLOB` value that this `Blob` object represents, starting at position `pos`, and returns the number of bytes written.
    `int` | `setBytes(long pos, byte[] bytes, int offset, int len)` Writes all or part of the given `byte` array to the `BLOB` value that this `Blob` object represents and returns the number of bytes written.
    `void` | `setDeleteOnFree(boolean deleteOnFree)` Assigns whether an attempt to delete the backing file is made in response to invocation of `free()`.
    `void` | `truncate(long len)` Truncates the `BLOB` value that this `Blob` object represents to be `len` bytes in length.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TEMP_FILE_PREFIX

          public static final java.lang.String TEMP_FILE_PREFIX

      See Also:
        Constant Field Values

    - #### TEMP_FILE_SUFFIX

          public static final java.lang.String TEMP_FILE_SUFFIX

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JDBCBlobFile

          public JDBCBlobFile()
                       throws java.sql.SQLException

      Convenience constructor; equivalent to JDBCBlobFile(true);
      Throws:
        `java.sql.SQLException` - If a file could not be created or if a security manager exists and its ``SecurityManager.checkWrite(java.lang.String)`` method does not allow a file to be created.

    - #### JDBCBlobFile

          public JDBCBlobFile(boolean deleteOnFree)
                       throws java.sql.SQLException

      Constructs a new instance backed by a File object created in response to invoking File.createTempFile(TEMP_FILE_PREFIX,TEMP_FILE_SUFFIX)

      Parameters:
        `deleteOnFree` - Assigns whether an attempt to delete the backing file is to be made in response to invocation of `free()`.
      Throws:
        `java.sql.SQLException` - If a file could not be created or if a security manager exists and its ``SecurityManager.checkWrite(java.lang.String)`` method does not allow a file to be created.

    - #### JDBCBlobFile

          public JDBCBlobFile(java.io.File file)
                       throws java.sql.SQLException

      Convenience constructor; equivalent to JDBCBlobFile(file, false);
      Parameters:
        `file` - used to back this BLOB instance.
      Throws:
        `java.sql.SQLException` - If an I/O error occurs, which is possible because the construction of the canonical pathname may require file system queries; if a required system property value cannot be accessed, or if a security manager exists and its ``SecurityManager.checkRead(java.io.FileDescriptor)`` method denies read access to the file

    - #### JDBCBlobFile

          public JDBCBlobFile(java.io.File file,
                              boolean deleteOnFree)
                       throws java.sql.SQLException

      Constructs a new instance backed by the given File object.
      Parameters:
        `file` - used to back this BLOB instance.
        `deleteOnFree` - Assigns whether an attempt to delete the backing file is to be made in response to invocation of `free()`.
      Throws:
        `java.sql.SQLException` - If an I/O error occurs, which is possible because the construction of the canonical pathname may require file system queries; if a required system property value cannot be accessed, or if a security manager exists and its ``SecurityManager.checkRead(java.io.FileDescriptor)`` method denies read access to the file

  - ### Method Detail

    - #### length

          public long length()
                      throws java.sql.SQLException

      Returns the number of bytes in the `BLOB` value designated by this `Blob` object.
      Specified by:
        `length` in interface `java.sql.Blob`
      Returns:
        length of the `BLOB` in bytes
      Throws:
        `java.sql.SQLException` - if there is an error accessing the length of the `BLOB`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getBytes

          public byte[] getBytes(long pos,
                                 int length)
                          throws java.sql.SQLException

      Retrieves all or part of the `BLOB` value that this `Blob` object represents, as an array of bytes. This `byte` array contains up to `length` consecutive bytes starting at position `pos`.
      Specified by:
        `getBytes` in interface `java.sql.Blob`
      Parameters:
        `pos` - the ordinal position of the first byte in the `BLOB` value to be extracted; the first byte is at position 1
        `length` - the number of consecutive bytes to be copied; the value for length must be 0 or greater
      Returns:
        a byte array containing up to `length` consecutive bytes from the `BLOB` value designated by this `Blob` object, starting with the byte at position `pos`
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value; if pos is less than 1 or length is less than 0
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2
      See Also:
        `setBytes(long, byte[])`

    - #### getBinaryStream

          public java.io.InputStream getBinaryStream()
                                              throws java.sql.SQLException

      Retrieves the `BLOB` value designated by this `Blob` instance as a stream.
      Specified by:
        `getBinaryStream` in interface `java.sql.Blob`
      Returns:
        a stream containing the `BLOB` data
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2
      See Also:
        `setBinaryStream(long)`

    - #### position

          public long position(byte[] pattern,
                               long start)
                        throws java.sql.SQLException

      Retrieves the byte position at which the specified byte array `pattern` begins within the `BLOB` value that this `Blob` object represents. The search for `pattern` begins at position `start`.
      Specified by:
        `position` in interface `java.sql.Blob`
      Parameters:
        `pattern` - the byte array for which to search
        `start` - the position at which to begin searching; the first position is 1
      Returns:
        the position at which the pattern appears, else -1
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` or if start is less than 1
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### position

          public long position(java.sql.Blob pattern,
                               long start)
                        throws java.sql.SQLException

      Retrieves the byte position in the `BLOB` value designated by this `Blob` object at which `pattern` begins. The search begins at position `start`.
      Specified by:
        `position` in interface `java.sql.Blob`
      Parameters:
        `pattern` - the `Blob` object designating the `BLOB` value for which to search
        `start` - the position in the `BLOB` value at which to begin searching; the first position is 1
      Returns:
        the position at which the pattern begins, else -1
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value or if start is less than 1
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### setBytes

          public int setBytes(long pos,
                              byte[] bytes)
                       throws java.sql.SQLException

      Writes the given array of bytes to the `BLOB` value that this `Blob` object represents, starting at position `pos`, and returns the number of bytes written. The array of bytes will overwrite the existing bytes in the `Blob` object starting at the position `pos`. If the end of the `Blob` value is reached while writing the array of bytes, then the length of the `Blob` value will be increased to accommodate the extra bytes.

      Note: If the value specified for `pos` is greater then the length+1 of the `BLOB` value then the behavior is undefined. Some JDBC drivers may throw a `SQLException` while other drivers may support this operation.

      ### HSQLDB-Specific Information:

      This operation affects only the content of the underlying file; it has no effect upon a value stored in a database. To propagate the updated Blob value to a database, it is required to supply the Blob instance to an updating or inserting setXXX method of a Prepared or Callable Statement, or to supply the Blob instance to an updateXXX method of an updatable ResultSet.

      Specified by:
        `setBytes` in interface `java.sql.Blob`
      Parameters:
        `pos` - the position in the `BLOB` object at which to start writing; the first position is 1
        `bytes` - the array of bytes to be written to the `BLOB` value that this `Blob` object represents
      Returns:
        the number of bytes written
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value or if pos is less than 1
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4
      See Also:
        `getBytes(long, int)`

    - #### setBytes

          public int setBytes(long pos,
                              byte[] bytes,
                              int offset,
                              int len)
                       throws java.sql.SQLException

      Writes all or part of the given `byte` array to the `BLOB` value that this `Blob` object represents and returns the number of bytes written. Writing starts at position `pos` in the `BLOB` value; `len` bytes from the given byte array are written. The array of bytes will overwrite the existing bytes in the `Blob` object starting at the position `pos`. If the end of the `Blob` value is reached while writing the array of bytes, then the length of the `Blob` value will be increased to accommodate the extra bytes.

      Note: If the value specified for `pos` is greater then the length+1 of the `BLOB` value then the behavior is undefined. Some JDBC drivers may throw a `SQLException` while other drivers may support this operation.

      ### HSQLDB-Specific Information:

      This operation affects only the content of the underlying file; it has no effect upon a value stored in a database. To propagate the updated Blob value to a database, it is required to supply the Blob instance to an updating or inserting setXXX method of a Prepared or Callable Statement, or to supply the Blob instance to an updateXXX method of an updatable ResultSet.

      Specified by:
        `setBytes` in interface `java.sql.Blob`
      Parameters:
        `pos` - the position in the `BLOB` object at which to start writing; the first position is 1
        `bytes` - the array of bytes to be written to this `BLOB` object
        `offset` - the offset into the array `bytes` at which to start reading the bytes to be set
        `len` - the number of bytes to be written to the `BLOB` value from the array of bytes `bytes`
      Returns:
        the number of bytes written
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value or if pos is less than 1
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4
      See Also:
        `getBytes(long, int)`

    - #### setBinaryStream

          public java.io.OutputStream setBinaryStream(long pos)
                                               throws java.sql.SQLException

      Retrieves a stream that can be used to write to the `BLOB` value that this `Blob` object represents. The stream begins at position `pos`. The bytes written to the stream will overwrite the existing bytes in the `Blob` object starting at the position `pos`. If the end of the `Blob` value is reached while writing to the stream, then the length of the `Blob` value will be increased to accommodate the extra bytes.

      Note: If the value specified for `pos` is greater then the length+1 of the `BLOB` value then the behavior is undefined. Some JDBC drivers may throw a `SQLException` while other drivers may support this operation.

      ### HSQLDB-Specific Information:

      Data written to the returned stream affects only the content of the underlying file; it has no effect upon a value stored in a database. To propagate the updated Blob value to a database, it is required to supply the Blob instance to an updating or inserting setXXX method of a Prepared or Callable Statement, or to supply the Blob instance to an updateXXX method of an updateable ResultSet.

      Specified by:
        `setBinaryStream` in interface `java.sql.Blob`
      Parameters:
        `pos` - the position in the `BLOB` value at which to start writing; the first position is 1
      Returns:
        a `java.io.OutputStream` object to which data can be written
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value or if pos is less than 1
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4
      See Also:
        `getBinaryStream()`

    - #### truncate

          public void truncate(long len)
                        throws java.sql.SQLException

      Truncates the `BLOB` value that this `Blob` object represents to be `len` bytes in length.

      Note: If the value specified for `pos` is greater then the length+1 of the `BLOB` value then the behavior is undefined. Some JDBC drivers may throw a `SQLException` while other drivers may support this operation.

      ### HSQLDB-Specific Information:

      This operation affects only the length of the underlying file; it has no effect upon a value stored in a database. To propagate the truncated Blob value to a database, it is required to supply the Blob instance to an updating or inserting setXXX method of a Prepared or Callable Statement, or to supply the Blob instance to an updateXXX method of an updatable ResultSet.

      Specified by:
        `truncate` in interface `java.sql.Blob`
      Parameters:
        `len` - the length, in bytes, to which the `BLOB` value that this `Blob` object represents should be truncated
      Throws:
        `java.sql.SQLException` - if there is an error accessing the `BLOB` value or if len is less than 0
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4

    - #### free

          public void free()
                    throws java.sql.SQLException

      This method frees the `Blob` object and releases the resources that it holds. The object is invalid once the `free` method is called.

      After `free` has been called, any attempt to invoke a method other than `free` will result in a `SQLException` being thrown. If `free` is called multiple times, the subsequent calls to `free` are treated as a no-op.

      ### HSQLDB-Specific Information:

      This operation closes any input and/or output streams obtained via `getBinaryStream()`, `getBinaryStream(long, long)` or `setBinaryStream(long)`.

      Additionally, if the property `isDeleteOnFree()` is true, then an attempt is made to delete the backing file.

      Specified by:
        `free` in interface `java.sql.Blob`
      Throws:
        `java.sql.SQLException` - if an error occurs releasing the Blob's resources
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6
      See Also:
        `setDeleteOnFree(boolean)`, `isDeleteOnFree()`

    - #### getBinaryStream

          public java.io.InputStream getBinaryStream(long pos,
                                                     long length)
                                              throws java.sql.SQLException

      Returns an `InputStream` object that contains a partial `Blob` value, starting with the byte specified by pos, which is length bytes in length.
      Specified by:
        `getBinaryStream` in interface `java.sql.Blob`
      Parameters:
        `pos` - the offset to the first byte of the partial value to be retrieved. The first byte in the `Blob` is at position 1
        `length` - the length in bytes of the partial value to be retrieved
      Returns:
        `InputStream` through which the partial `Blob` value can be read.
      Throws:
        `java.sql.SQLException` - if pos is less than 1 or if pos is greater than the number of bytes in the `Blob` or if pos + length is greater than the number of bytes in the `Blob`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6

    - #### getFile

          public java.io.File getFile()

      Retrieves the canonical `File` object denoting the file that backs this BLOB.
      Returns:
        the file that backs this BLOB.

    - #### isDeleteOnFree

          public boolean isDeleteOnFree()

      Retrieves whether an attempt to delete the backing file is made in response to invocation of `free()`.
      Returns:
        true if backing file deletion is attempted; otherwise false.

    - #### setDeleteOnFree

          public void setDeleteOnFree(boolean deleteOnFree)

      Assigns whether an attempt to delete the backing file is made in response to invocation of `free()`.
      Parameters:
        `deleteOnFree` - the new value to assign

Copyright © 2001 - 2018 HSQL Development Group.